#include "AbstractDynamicLibrary.hpp"
#include "Exception.hpp"
#include "Trace.hpp"

namespace Danu
{	
	
	/* static */ AbstractDynamicLibrary* AbstractDynamicLibrary::theDynamicLibrary = 0;

	/* static */ void AbstractDynamicLibrary::loadLibrary()
	{
		FUNCTRACE_DEVELOP();
		AbstractDynamicLibrary::getLibrary()->load();
	}

	/* static */ void AbstractDynamicLibrary::unloadLibrary()
	{		
		FUNCTRACE_DEVELOP();
		AbstractDynamicLibrary::getLibrary()->unload();
		AbstractDynamicLibrary::setLibrary(0);
	}

	/* static */ AbstractDynamicLibrary* AbstractDynamicLibrary::getLibrary()
	{		
		if(theDynamicLibrary == 0)
		{			
			theDynamicLibrary = CreateDynamicLibrary();
		}		
		return theDynamicLibrary;
	}

	/* static */ void	AbstractDynamicLibrary::setLibrary(AbstractDynamicLibrary* anAbstractDynamicLibrary)
	{
		delete theDynamicLibrary;
		theDynamicLibrary = anAbstractDynamicLibrary;
	}

	AbstractDynamicLibrary::AbstractDynamicLibrary()
	{
		FUNCTRACE_DEVELOP();
	}

	AbstractDynamicLibrary::~AbstractDynamicLibrary()
	{
		FUNCTRACE_DEVELOP();
	}
}; // namespace Danu
