#ifndef AbstractWaitableObject_hpp
#define AbstractWaitableObject_hpp

#include "DanuConfig.h"
#include <noncopyable.hpp>

namespace Danu
{
	/// The abstract base class for objects that can be waited upon.
	class DANUIMPEXP AbstractWaitableObject : public boost::noncopyable
	{
		public:
			virtual ~AbstractWaitableObject(){}
			/**
			@param aTimeOut: if this is -1, this function should wait forever
			*/
			virtual void                              wait( long aTimeOut = -1) = 0;
			virtual void                              signal() = 0;
			virtual void                              broadcast() = 0;
	};
}; // namespace Danu

#endif // AbstractWaitableObject_hpp
