#ifndef CountingSemaphore_hpp
#define CountingSemaphore_hpp

#include "AbstractLockableObject.hpp"
#include <pthread.h>

namespace Danu
{
	/**
	For more info about the implementation of this class: it is implemented with POSIX semantics.
	No support for interprcess MutexSemaphore as the PThreads library does not support it (yet)
	*/
	class DANUIMPEXP CountingSemaphore : public AbstractLockableObject
	{
		public:
			CountingSemaphore ();
			~CountingSemaphore ();

			/// \name AbstractLockableObject interface
			/// @{
			virtual void lock( long aTimeOut = -1);
			virtual void trylock();
			virtual void unlock();
			/// @}
		protected:
			/// \name common (de)initialization functions
			/// @{
			virtual void init();
			virtual void deinit();
			/// @}
	};
}; // namespace Danu

#endif // CountingSemaphore_hpp
