#include "DanuUtils.hpp"
#include "Trace.hpp"

#ifdef DANU_PLATFORM_WINDOWS
#include <windows.h>
#endif

namespace Danu
{
	std::string GetErrorIdAsString(unsigned long anErrorId)
	{
		#ifdef DANU_PLATFORM_WINDOWS
		
			LPVOID messageBuffer;
			unsigned long result = ::FormatMessage(	FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
													NULL,
													anErrorId,
													MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
													(LPTSTR) &messageBuffer,
													0,
													NULL);
			if(result == 0)
			{
				std::string errorIdAsString = std::string("Unable to find message for anErrorId ") + Danu::integerToString((unsigned long)anErrorId) + std::string(", GetLastError() = ") + Danu::integerToString(::GetLastError());
				LocalFree(messageBuffer);
				return errorIdAsString;
			}
			std::string errorIdAsString((LPTSTR)messageBuffer);
			LocalFree(messageBuffer);
			return errorIdAsString;
		#elif defined DANU_PLATFORM_LINUX
			std::string errorIdAsString = std::string("Unable to find message for anErrorId ") + Danu::integerToString((unsigned long)anErrorId);
			return errorIdAsString;
		#endif // __DANULINUX__
	}
} // namspace Danu