#include "EventSemaphore.hpp"

namespace Danu
{
	EventSemaphore::EventSemaphore()
		:	handle(PTHREAD_COND_INITIALIZER)
	{
		init();
	}
	
	EventSemaphore::~EventSemaphore ()
	{
		deinit();
	}
		
	void EventSemaphore::wait( long aTimeOut /*= -1*/)
	{
		pthread_cond_wait(&handle,&mutex.getHandle());
		mutex.unlock();
	}
	
	void EventSemaphore::signal()
	{
		pthread_cond_signal(&handle);
	}
	
	void EventSemaphore::broadcast()
	{
		pthread_cond_broadcast(&handle);
	}
	
	void EventSemaphore::init()
	{
		mutex.lock();
		pthread_cond_init(&handle,NULL);
	}
	
	void EventSemaphore::deinit()
	{
		pthread_cond_destroy(&handle);
	}
	
	
}; // namespace Danu
