#include "MutexSemaphore.hpp"
#include "Trace.hpp"
#include <iostream>

namespace Danu
{
	MutexSemaphore::MutexSemaphore()
		:	handle(PTHREAD_MUTEX_INITIALIZER)
	{
		init();
	}
	
	MutexSemaphore::~MutexSemaphore()
	{
		deinit();
	}
	
	void MutexSemaphore::lock( long aTimeOut /* = -1 */)
	{
		pthread_mutex_lock(&handle);
	}
	
	void MutexSemaphore::trylock()
	{
		pthread_mutex_trylock(&handle);
	}
	
	void MutexSemaphore::unlock()
	{
		pthread_mutex_unlock(&handle);
	}
	
	void MutexSemaphore::init()
	{
		pthread_mutex_init(&handle, NULL);
	}
	
	void MutexSemaphore::deinit()
	{
		pthread_mutex_destroy(&handle);
	}
			
}; // namespace Danu
