#ifndef RWSemaphore_hpp
#define RWSemaphore_hpp

#include "MutexSemaphore.hpp"

namespace Danu
{
	/**
	For more info about the implementation of this class: it is implemented with POSIX semantics.
	No support for interprocess RWSemaphore as the PThreads library does not support it (yet)
	*/
	class DANUIMPEXP RWSemaphore : public MutexSemaphore
	{
		public:
			RWSemaphore();
			~RWSemaphore();

			/// \name AbstractLockableObject interface
			/// @{
			virtual void                              lock( long aTimeOut = -1);
			virtual void                              trylock();
			virtual void                              unlock();
			/// @}

		protected:
			/// \ name common (de)initialization functions
			/// @{
			virtual void init();
			virtual void deinit();
			/// @}

		private:
			pthread_rwlock_t 			rwlock;
			pthread_rwlockattr_t		rwlockAttribute;
	};

}; // namespace Danu

#endif // RWSemaphore_hpp
