#ifndef ThreadFunction_hpp
#define ThreadFunction_hpp

#include "DanuConfig.h"

namespace Danu
{
	class AbstractThreadFunction
	{
	   public:
	      virtual void                              run() = 0;
	};	
	
	template < class T >
	class ThreadMemberFunction : public AbstractThreadFunction
	{
		public:
	    	ThreadMemberFunction(  T&obj, void (T :: *mem)())
				:	object(obj),
	      			member(mem)
	      	{}
			virtual void run()
			{
	   			(object.*member)();
			}		
	   private:
	      T& object;
	      void (T::*member)();
	};
} // namespace Danu

#endif
